//	ExtraHealth.cpp - Damage action requiring the vader to be hit twice before
//					  dying.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "VaderExplosion.h"
#include "ExtraHealth.h"
#include "../Vader.h"

//------------------------------------------------------------------------------
ExtraHealth::ExtraHealth():
health(2)
{

}

//------------------------------------------------------------------------------
ExtraHealth::~ExtraHealth()
{

}

//------------------------------------------------------------------------------
void ExtraHealth::damageTaken(Vader& vader, NewGamePlayState& state)
{
	--health;
	if(!health)
		vader.setDead(true);
	else
	{
		int x, y;
		Array2D<bool, 7, 7>& image = vader.getImage();
		Array2D<bool, 7, 7> explosionImage(false);
		shared_ptr<VaderExplosion> explosion;

		for(x=0;x<7;++x)
		{
			explosionImage[0][x] = image[0][x];
			explosionImage[6][x] = image[6][x];
			image[0][x] = false;
			image[6][x] = false;
		}
		for(y=0;y<7;++y)
		{
			explosionImage[y][0] = image[y][0];
			explosionImage[y][6] = image[y][6];
			image[y][0] = false;
			image[y][6] = false;
		}

		state.addVaderExplosion(shared_ptr<VaderExplosion>(new VaderExplosion(explosionImage,
														   vader.getPosition(),
														   vader.getColour(),
														   vader.getWingMotion())));
	}
}
