//	ExtraHealth.h - Damage action requiring the vader to be hit twice before
//					dying.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#ifndef EXTRAHEALTH_H_
#define EXTRAHEALTH_H_

#include "../VaderDamageAction.h"

///	Damage action requiring the vader to be hit twice before dying.
class ExtraHealth : public VaderDamageAction
{
  public:
	///	Constructor.
	ExtraHealth();
	///	Destructor.
	~ExtraHealth();

	///	Called when the owning vader takes damage.
	void damageTaken(Vader& vader, NewGamePlayState& state);

	///	Returns a description of what the action does.
	const std::wstring getDescription() const {return L"Takes two hits to kill.";};
  private:
	///	How much health the vader has.
	int health;
};

#endif
