//	Retaliate.cpp - Fires back at the player when it takes damage.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "../projectiles/RetaliateBullet.h"
#include "Retaliate.h"
#include "../Vader.h"

//------------------------------------------------------------------------------
Retaliate::Retaliate()
{

}

//------------------------------------------------------------------------------
Retaliate::~Retaliate()
{

}

//------------------------------------------------------------------------------
void Retaliate::damageTaken(Vader& vader, NewGamePlayState& state)
{
	state.addVaderProjectile(shared_ptr<VaderProjectile>(new RetaliateBullet(vader.getPosition())));
	vader.setDead(true);
}
