//	PlanetBox.cpp - The Planet info box.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "drawing/Drawer.h"
#include "PlanetBox.h"

//------------------------------------------------------------------------------
PlanetInfoBox::PlanetInfoBox(shared_ptr<Planet>& p, const TwoFloats& drawSize):
planet(p),
infoPos(((drawSize.x*0.5f) - 211.0f), ((drawSize.y*0.5f) - 261.5f)),
infoSize(422.0f, 523.0f)
{
	
}

//------------------------------------------------------------------------------
PlanetInfoBox::~PlanetInfoBox()
{

}

//------------------------------------------------------------------------------
void PlanetInfoBox::draw(shared_ptr<Drawer>& d)
{
	d->drawText(planet->getName(),
				L"Font1",
				layouts[PlanetName],
				TwoFloats(infoPos.x+12.0f, infoPos.y+41.0f),
						  (infoSize.x-24.0f-31.0f),
						  TextLayout::Centre,
						  1.0f,
						  ThreeFloats(1.0f));

	d->drawText(L"This will be a short description of the planet, its inhabitants, and its various resources, of which you will be able to make use in your desperate attempt to defeat the incoming invasion fleets.",
				L"Font2",
				layouts[PlanetDescription],
				TwoFloats(infoPos.x+24.0f, infoPos.y+64.0f+40.0f),
				infoSize.x-32.0f,
				TextLayout::Left,
				1.0f,
				ThreeFloats(1.0f));
}

//------------------------------------------------------------------------------
void PlanetInfoBox::setPlanet(shared_ptr<Planet>& p)
{
	int i;

	planet = p;
	for(i=0;i<NumLayouts;++i)
		layouts[i].clear();
}
