//	Explode2.h - Damage action which fires a circle of Explode2Bullets when the
//				vader dies.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#ifndef EXPLODE2_H_
#define EXPLODE2_H_

#include "../VaderKillAction.h"

///	Damage action which fires a circle of Explode2Bullets when the vader dies.
class Explode2 : public VaderKillAction
{
  public:
	///	Constructor.
	Explode2();
	///	Destructor.
	~Explode2();

	///	Called when the owning vader dies.
	void killed(Vader& vader, NewGamePlayState& state);

	///	Returns a description of what the action does.
	const std::wstring getDescription() const {return L"Explodes into 8 Fragile Bullets.";};
};

#endif
