//	Explode3.cpp - Damage action which fires a circle of HomingBullets when the
//				   vader dies.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "../projectiles/HomingBullet.h"
#include "../NewGamePlayState.h"
#include "MiscHelper.h"
#include "../Vader.h"
#include "Explode3.h"

#include <cmath>

//------------------------------------------------------------------------------
Explode3::Explode3()
{

}

//------------------------------------------------------------------------------
Explode3::~Explode3()
{

}

//------------------------------------------------------------------------------
void Explode3::killed(Vader& vader, NewGamePlayState& state)
{
	int i;
	TwoFloats dir;

	for(i=1;i<8;i+=2)
	{
		dir.x = sinf(((float)i/8.0f) * 2.0f * NIALL_PI);
		dir.y = cosf(((float)i/8.0f) * 2.0f * NIALL_PI);

		state.addVaderProjectile(shared_ptr<VaderProjectile>(new HomingBullet(vader.getPosition(), dir)));
	}
}
