//	Explode4.cpp - Damage action which fires 2 FriendlyFires when the vader
//				   dies.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "../projectiles/FriendlyFire.h"
#include "../NewGamePlayState.h"
#include "MiscHelper.h"
#include "../Vader.h"
#include "Explode4.h"

#include <cmath>

//------------------------------------------------------------------------------
bool Explode4::dir = false;

//------------------------------------------------------------------------------
Explode4::Explode4()
{

}

//------------------------------------------------------------------------------
Explode4::~Explode4()
{

}

//------------------------------------------------------------------------------
void Explode4::killed(Vader& vader, NewGamePlayState& state)
{
	if(dir)
	{
		state.addVaderProjectile(shared_ptr<VaderProjectile>(new FriendlyFire(vader.getPosition(),
																			  TwoFloats(-1.0f, 0.0f))));
		state.addVaderProjectile(shared_ptr<VaderProjectile>(new FriendlyFire(vader.getPosition(),
																			  TwoFloats(1.0f, 0.0f))));
	}
	else
	{
		state.addVaderProjectile(shared_ptr<VaderProjectile>(new FriendlyFire(vader.getPosition(),
																			  TwoFloats(0.0f, -1.0f))));
		state.addVaderProjectile(shared_ptr<VaderProjectile>(new FriendlyFire(vader.getPosition(),
																			  TwoFloats(0.0f, 1.0f))));
	}
	dir = !dir;
}
