//	Split.cpp - When the vader dies, this generates 2 smaller vaders in its
//			    place.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#include "../NewGamePlayState.h"
#include "MiscHelper.h"
#include "../Vader.h"
#include "Split.h"

#include <cmath>

//------------------------------------------------------------------------------
Split::Split()
{

}

//------------------------------------------------------------------------------
Split::~Split()
{

}

//------------------------------------------------------------------------------
void Split::killed(Vader& vader, NewGamePlayState& state)
{
	int x, y;
	TwoFloats tempPos(vader.getPosition());
	const shared_ptr<VaderKillAction> killAction;
	Array2D<bool, 7, 7> newImage(vader.getImage());
	std::vector<shared_ptr<VaderDamageAction> > damageActions;

	for(x=0;x<7;++x)
	{
		newImage[0][x] = false;
		newImage[6][x] = false;
	}
	for(y=0;y<7;++y)
	{
		newImage[y][0] = false;
		newImage[y][6] = false;
	}

	tempPos.x -= 40.0f;
	state.addVader(shared_ptr<Vader>(new Vader(vader.getName(),
											   tempPos,
											   newImage,
											   vader.getProjectileCreators(),
											   damageActions,
											   killAction,
											   state,
											   true)));
	tempPos.x += 80.0f;
	state.addVader(shared_ptr<Vader>(new Vader(vader.getName(),
											   tempPos,
											   newImage,
											   vader.getProjectileCreators(),
											   damageActions,
											   killAction,
											   state,
											   true)));
}
