//	Split.h - When the vader dies, this generates 2 smaller vaders in its
//			  place.
//  ----------------------------------------------------------------------------
//	This file is part of 'NiallsAVLib', base code for any kind of audiovisual
//	apps.
//	Copyright (C) 2012  Niall Moody
//	
//	This program is free software: you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program.  If not, see <http://www.gnu.org/licenses/>.
//	----------------------------------------------------------------------------

#ifndef SPLIT_H_
#define SPLIT_H_

#include "../VaderKillAction.h"

///	When the vader dies, this generates 2 smaller vaders in its place.
class Split : public VaderKillAction
{
  public:
	///	Constructor.
	Split();
	///	Destructor.
	~Split();

	///	Called when the owning vader dies.
	void killed(Vader& vader, NewGamePlayState& state);

	///	Returns a description of what the action does.
	const std::wstring getDescription() const {return L"Splits into 2 smaller vaders.";};
};

#endif
